<?php
require_once('wurfldb-config.php');
 	define('GENERIC','generic');
 	define('ROOT','root');
 	
 	global $countQueries;
 	$countQueries = 0;
 	
 	class WurflDevice
 	{
 		var $id;
 		var $userAgent;
 		var $fallBack;
 		var $brand;
 		var $model;
 		
 		function WurflDevice($id,$userAgent,$fallBack, $brand, $model)
 		{
 			$this->id = $id;
 			$this->userAgent = $userAgent;
 			$this->fallBack = $fallBack;
 			$this->brand = $brand;
 			$this->model = $model;
 		}
 		
 		function getId()
 		{
 			return $this->id;
 		} 
 		function getModel()
 		{
 			return $this->model;
 		} 
 		function getBrand()
 		{
 			return $this->brand;
 		} 
 		
 		function getUserAgent()
 		{
 			return $this->userAgent;
 		} 

 		function getFallBack()
 		{
 			return $this->fallBack;
 		} 
 	}

	/**
	 * truncate a string to 3/4 of it's length
	 */
	function reduceString($str)
	{
		$len = floor((strlen($str) * 3 ) / 4);
		return substr($str,0,$len);
	}
	
/**
 * perform a mysql query.
 * if connection is not specified, use the default mysql connection
 * @return the same as mysql_query
 */
	function doQuery($query, $connection = null)
	{
 		global $countQueries;
		$result = null;
		if($connection)
		{
			$result = mysql_query($query, $connection);
		}
		else
		{
			$result = mysql_query($query);
		}
		++$countQueries;
		return $result;
	}
	
	/**
	 * escape a string according to MySQL convetions, and wrap in 
	 * single quotes.  Used for all data strings in sql statements as a 
	 * bulwark against SQL-injection vulnerabilities
	 */
	function enquote($field)
	{
		return "'" . mysql_escape_string($field) . "'";
	}
	
	/**
	 * get the full fall-back device chain
	 */
	function getDeviceChain($deviceId, $connection = null)
	{
		$result[] = $did = $deviceId;
		
		do
		{
			$devquery = 'SELECT fall_back from ' 
				. $WURFL_SCHEMA . '.wurfl_device '
				. 'where id = ' . enquote($did);
	
			$rs = doQuery($devquery, $connection);
			if(($row = mysql_fetch_assoc($rs)) != null)
			{
				$did = $row['fall_back'];
				if($did != ROOT)
				{
					$result[] = $did;
				}
			}
			else
			{
				$did = null;
			}
		}
		while($did && $did != ROOT);
		
		return $result;
	}
	
	function getDevice($id,$caps = null,$connection = null)
	{
		$devquery = 'SELECT * from ' 
			. $WURFL_SCHEMA . '.wurfl_device '
			. 'where id = ' . enquote($id);

		$rs = doQuery($devquery, $connection);
		$result = null;
		if(($devrow = mysql_fetch_assoc($rs)) != null)
		{
			$brand = null;
			$model = null;
			if($caps == null)
			{
				$brand = getCapabilityForDevice($devrow['id'],
					'brand_name',$connection);
				$model = getCapabilityForDevice($devrow['id'],
					'model_name',$connection);
			}
			else
			{
				$brand = $caps['brand_name'];
				$model = $caps['model_name'];
			}
			$result = new WurflDevice($devrow['id'],$devrow['user_agent'],
				$devrow['fall_back'], $brand, $model);
		}
		return $result;
	}
	

	/** matches the supplied user-agent to the nearest matching device id 
	 * @return a device id
	 */	
	
	function getDeviceId($userAgent, $connection = null)
	{
		return getDeviceIdImpl($userAgent,false,$connection);
	}

	/** matches the supplied user-agent to a device id only if
	 * the user agent matches exactly
	 * @return a device id
	 */	
	function getDeviceIdStrict($userAgent, $connection = null)
	{
		return getDeviceIdImpl($userAgent,true,$connection);
	}
	
	/** matches the supplied user-agent to a specific deviceid 
	 * used by both getDeviceIdXXX methods
	 * @return a device id
	 */	
	function getDeviceIdImpl($userAgent, $strict = false, $connection = null)
	{
		if(strncmp($userAgent,"Vodafone/",strlen("Vodafone/")) == 0)
		{
			return getDeviceIdImpl(
				substr($userAgent,strlen("Vodafone/")), $strict, $connection);
		}
		$agent = $userAgent;
		$id = null;
		while($id == null)
		{
			$query = 'SELECT id,user_agent FROM ' 
				. $WURFL_SCHEMA . '.wurfl_device '
				. ' WHERE user_agent LIKE ' . enquote($agent)
				. ' ORDER BY CHAR_LENGTH(user_agent) DESC';
			$rs = doQuery($query,$connection);
			while(($row = mysql_fetch_assoc($rs)) != null)
			{
				$dba = $row['user_agent'];
				if(strncmp($userAgent,$dba,strlen($dba)) == 0)
				{
					$id = $row['id'];
					break;
				}
			}
			if($strict == false && $id == null)
			{
				$agent = reduceString($agent) . "%";
				if(strlen($agent) <= 1)
				{
					break;
				}
			}
			else
			{
				break;
			}
		}
		
		if($id == null && $strict == false)
		{
			if(strstr($userAgent,"UP.Browser/7")) 
			{
				$id = "opwv_v7_generic";
			}
			else if(strstr($userAgent,"UP.Browser/6")) 
			{
				$id = "opwv_v6_generic";
			}
			else if(strstr($userAgent,"UP.Browser/5")) 
			{
				$id =  "upgui_generic";
			}
			else if(strstr($userAgent,"UP.Browser/4")) 
			{
				$id = "uptext_generic";
			}
			else if(strstr($userAgent,"Series60")) 
			{
				$id = "nokia_generic_series60";
			}
			//web browsers?
			else if(strstr($userAgent,"Mozilla/4.0")) 
			{
				$id = "generic_web_browser";
			}
			else if(strstr($userAgent,"Mozilla/5.0")) 
			{
				$id = "generic_web_browser";
			}
			else if(strstr($userAgent,"Mozilla/6.0")) 
			{
				$id = "generic_web_browser";
			}
		}
		return $id == null ? GENERIC : $id;
	}

 	function getAllUserAgents($connection = null)
 	{
 		$query = 'SELECT DISTINCT user_agent from ' 
			. $WURFL_SCHEMA . '.wurfl_device '
			. ' ORDER BY user_agent';
				
		$rs = doQuery($query);
		$result = array();
		while(($row = mysql_fetch_assoc($rs)) != null)
		{
			if(! empty($row['user_agent']))
			{
				$result[] = $row['user_agent'];
			}
		}
		return $result;
 	}
 	

	/**
	 * @return the value of any specific capability for this device
	 */	
	function getCapabilityForDevice($deviceId, $cap, $connection = null)
	{
		$value = null;
		$deviceChain = getDeviceChain($deviceId, $connection);
		
		foreach($deviceChain as $dd)
		{
			$capquery = "SELECT value from $WURFL_SCHEMA.wurfl_capability "
				. " WHERE deviceid = " . enquote($dd)
				. " AND name = " . enquote($cap);
			$rs = doQuery($capquery,$connection); 
			if(($row = mysql_fetch_assoc($rs)) != null)
			{
				$value = $row["value"];
				break;
			}
		}
		return $value;
	}
	/**
	 * @return array a name/value listing of all capabilities defiined for
	 * this device including all fall-back devices 
	 */
	function getCapabilitiesForDeviceId($deviceId, $connection = false)
	{
		return getCapabilitiesForDeviceIdImpl($deviceId,false,$connection);
	}
	/**
	 * @return array a name/value listing of all capabilities defiined at
	 * this device level
	 */
	function getCapabilitiesForDeviceIdStrict($deviceId, $connection = false)
	{
		return getCapabilitiesForDeviceIdImpl($deviceId,true,$connection);
	}
	
	/**
	 * @return array a name/value listing of all capabilities for this 
	 * device id ddepending on parameters.  Using by both 
	 * getCapabilitiesForDeviceIdXXX functions
	 */
	function & getCapabilitiesForDeviceIdImpl($deviceId, $top = false, $connection = false)
	{
		
		$deviceChain = array();
		$result = array();
		if($top == false)
		{
			$deviceChain = getDeviceChain($deviceId, $connection);
		}
		else
		{
			$deviceChain[] = $deviceId;
		}
		
		foreach($deviceChain as $dd)
		{
			$capquery 
				= "SELECT name,value from $WURFL_SCHEMA .wurfl_capability "
				. " WHERE deviceid = " . enquote($dd);
			$rs = doQuery($capquery,$connection);
			while(($row = mysql_fetch_assoc($rs)) != null)
			{
				$n = $row['name'];
				if(! isset($result[$n]))
				{
					$result[$n] = $row['value'];
				}
			}
		}
		ksort($result);
		return $result;
	}
	
?>
